CAD开发者社区

 找回密码
 立即注册

QQ登录

只需一步,快速开始

AutoCAD 2021 开发者帮助

AddFitPoint 方法 (ActiveX)

2024-5-18 18:32| 发布者: admin| 查看: 79| 评论: 0|原作者: admin|来自: AutoCAD

AddFitPoint 方法 (ActiveX)

将拟合点添加到给定索引处的样条曲线。

支持的平台:仅限 Windows

签名

VBA:

object.AddFitPoint Index, FitPoint
对象

类型:样条曲线

此方法应用到的对象。

指数

访问:仅输入

类型:整数

在拟合点列表中的位置以添加拟合点。如果索引为负数,则该点将添加到样条曲线的开头。如果索引超过样条曲线中的拟合点数,则该点将添加到样条曲线的末端。

FitPoint的

访问:仅输入

类型:变体(双打的三元素阵列)

指定要添加的拟合点的 3D WCS 坐标。

返回值 (RetVal)

无返回值。

言论

AutoCAD 将添加该点,并在新点集中重新调整样条。若要查看更改,请使用 or 方法。UpdateRegen

例子

VBA:

Sub Example_AddFitPoint()
    ' This example creates a spline object in model space.
    ' It then adds a fit point to the spline.

    ' Create the spline
    Dim splineObj As AcadSpline
    Dim startTan(0 To 2) As Double
    Dim endTan(0 To 2) As Double
    Dim fitPoints(0 To 8) As Double
    
    startTan(0) = 0.5: startTan(1) = 0.5: startTan(2) = 0
    endTan(0) = 0.5: endTan(1) = 0.5: endTan(2) = 0
    fitPoints(0) = 1: fitPoints(1) = 1: fitPoints(2) = 0
    fitPoints(3) = 5: fitPoints(4) = 5: fitPoints(5) = 0
    fitPoints(6) = 10: fitPoints(7) = 0: fitPoints(8) = 0
    
    ' Create the spline object
    Set splineObj = ThisDrawing.ModelSpace.AddSpline(fitPoints, startTan, endTan)
    ZoomAll
    MsgBox "The Spline has " & splineObj.NumberOfFitPoints & " fit points.", , "AddFitPoint Example"
    
    ' Define the new fit point
    Dim newFitPoint(0 To 2) As Double
    newFitPoint(0) = 8: newFitPoint(1) = 5: newFitPoint(2) = 0
    
    ' Add the new fit point at the first index in the spline's array of points
    splineObj.AddFitPoint 1, newFitPoint
    ThisDrawing.Regen True
    MsgBox "A fit point has been added at Index:1  WCS: 8, 5, 0" & vbCrLf & "The Spline has " & splineObj.NumberOfFitPoints & " fit points.", , "AddFitPoint Example"

End Sub

可视化 LISP:

(vl-load-com)
(defun c:Example_AddFitPoint()
    ;; This example creates a spline object in model space.
    ;; It then adds a fit point to the spline.
    (setq acadObj (vlax-get-acad-object))
    (setq doc (vla-get-ActiveDocument acadObj))
  
    ;; Create the spline
    (setq startTan (vlax-3d-point 0.5 0.5 10)
          endTan (vlax-3d-point 0.5 0.5 10))
    (setq fitPoints (vlax-make-safearray vlax-vbDouble '(0 . 8)))
    (vlax-safearray-fill fitPoints '(1 1 10
                                     5 5 10
                                     10 0 10
                                    )
    )
    
    ;; Create the spline object
    (setq modelSpace (vla-get-ModelSpace doc))  
    (setq splineObj (vla-AddSpline modelSpace fitPoints startTan endTan))
    (vla-ZoomAll acadObj)
    (alert (strcat "The Spline has " (itoa (vla-get-NumberOfFitPoints splineObj)) " fit points."))
    
    ;; Define the new fit point
    (setq newFitPoint (vlax-3d-point 8 5 0))
    
    ;; Add the new fit point at the first index in the spline's array of points
    (vla-AddFitPoint splineObj 1 newFitPoint)
    (vla-Regen doc :vlax-true)
    (alert (strcat "A fit point has been added at Index:1  WCS: 8, 5, 0"
		                 "\nThe Spline has " (itoa (vla-get-NumberOfFitPoints splineObj)) " fit points."
           )
    )
)

路过

雷人

握手

鲜花

鸡蛋

最新评论

QQ|Archiver|CAD开发者社区 ( 苏ICP备2022047690号-1   苏公网安备32011402011833)

GMT+8, 2025-1-19 06:39

Powered by Discuz! X3.4

Copyright © 2001-2021, Tencent Cloud.

返回顶部